package cn.estsh.i3plus.ext.mes.pcn.pojo.context;

import cn.estsh.i3plus.ext.mes.pcn.pojo.util.MesPcnExtConstWords;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesAssemblyNosortCfg;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.util.StringUtils;

import java.io.Serializable;

/**
 * 生产过程上下文对象-装配件清单信息(非排序)
 */
@Data
public class MesProductionAssemblyNosortContext extends MesProductionAssemblyContext implements Serializable {

    private static final long serialVersionUID = -6507517107073405709L;

    @ApiParam(value = "BOM明细ID")
    private String bomDetailId;

    @ApiParam(value = "是否可复用条码")
    private Integer isRepeat;

    @ApiParam(value = "是否可复用条码是否写入上下文进行复用")
    private Integer isRepeat2Cache = CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue();

    @ApiParam(value = "是否忽略回车")
    private Integer isIgnoreEntry;

    @ApiParam(value = "工序用量")
    private Integer qty;

    @ApiParam(name = "产成品图")
    private String outPartNoPic;

    public MesProductionAssemblyNosortContext() {}

    public MesProductionAssemblyNosortContext copy(MesProdRuleContext prodRuleContext, MesAssemblyNosortCfg assemblyNosortCfg, String assemblySn) {
        BeanUtils.copyProperties(assemblyNosortCfg, this);
        BeanUtils.copyProperties(prodRuleContext, this);
        this.sourceId = assemblyNosortCfg.getId();
        this.partNo = prodRuleContext.getOutPartNo();
        if (StringUtils.isEmpty(this.routeSeq)) this.routeSeq = MesPcnExtConstWords.ZERO;
        this.assemblyStatus = MesExtEnumUtil.ASSEMBLY_STATUS.ASSEMBLY_STATUS_30.getValue();
        this.isSkip = CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue();
        if (MesExtEnumUtil.ASSEMBLY_MATCH_TYPE.MATCH_TYPE_50.getValue() == this.matchType || MesExtEnumUtil.ASSEMBLY_MATCH_TYPE.MATCH_TYPE_60.getValue() == this.matchType)
            this.assemblyStatus = MesExtEnumUtil.ASSEMBLY_STATUS.ASSEMBLY_STATUS_10.getValue();
        if (!StringUtils.isEmpty(assemblySn)) {
            this.assemblySn = assemblySn;
            this.isRepeat2Cache = CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue();
            this.assemblyStatus = MesExtEnumUtil.ASSEMBLY_STATUS.ASSEMBLY_STATUS_10.getValue();
        }
        return this;
    }

    public MesProductionAssemblyNosortContext assemblyStatus() {
        this.assemblyStatus = MesExtEnumUtil.ASSEMBLY_STATUS.ASSEMBLY_STATUS_10.getValue();
        return this;
    }

    public MesProductionAssemblyNosortContext assemblySkip() {
        this.assemblyStatus = MesExtEnumUtil.ASSEMBLY_STATUS.ASSEMBLY_STATUS_40.getValue();
        this.isSkip = CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue();
        return this;
    }

    public MesProductionAssemblyNosortContext assemblySn(String assemblySn) {
        this.assemblySn = assemblySn;
        return this;
    }

    public MesProductionAssemblyNosortContext productSnId(Long productSnId) {
        this.productSnId = productSnId;
        return this;
    }

    public MesProductionAssemblyNosortContext copy(MesAssemblyNosortCfg assemblyNosortCfg) {
        BeanUtils.copyProperties(assemblyNosortCfg, this);
        if (StringUtils.isEmpty(this.routeSeq)) this.routeSeq = MesPcnExtConstWords.ZERO;
        this.assemblyStatus = MesExtEnumUtil.ASSEMBLY_STATUS.ASSEMBLY_STATUS_30.getValue();
        if (MesExtEnumUtil.ASSEMBLY_MATCH_TYPE.MATCH_TYPE_50.getValue() == this.matchType || MesExtEnumUtil.ASSEMBLY_MATCH_TYPE.MATCH_TYPE_60.getValue() == this.matchType)
            this.assemblyStatus = MesExtEnumUtil.ASSEMBLY_STATUS.ASSEMBLY_STATUS_10.getValue();
        return this;
    }

}
